using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;

using System.Xml.Serialization;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Runtime.Serialization;

using Mizel.Neuro;

namespace WindowsApplication1
{
    public partial class DarkNeuromatik : Form
    {
        DatenNetz dn;
        DatenMuster _DatenMuster = new DatenMuster(16, 300);
        DatenNetzBerechnen dnr;

        public DarkNeuromatik()
        {
            InitializeComponent();                        
            ResetControl();

            dn = new DatenNetz(16, 16, 8);
            propertyGrid1.SelectedObject = dn;            
            dnr = new DatenNetzBerechnen(dn);
            dnr.Step += new EventHandler(dnr_Step);
            dnr.Progress += new EventHandler(dnr_Progress);
        }


        private void pictureBox1_Click(object sender, EventArgs e)
        {

            
        }

        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            if (pictureBox1.BackgroundImage == null)
                pictureBox1.BackgroundImage = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Bitmap img = (Bitmap)pictureBox1.BackgroundImage;
            int units = _DatenMuster.Units;
            int unitslength = _DatenMuster.UnitsLength;

            int posx = (e.X) / unitslength;
            int posy = (e.Y) / unitslength;

            _DatenMuster.PixelChange(posx, posy);
            ResetControl();
        }

                  


        private void button1_Click(object sender, EventArgs e)
        {
            
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
        int[] dataset = new int[9];
        DatenMuster dp=new DatenMuster(9,new Size(300,300));
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {

        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {

            //pictureBox2.Invalidate();
        }

        private void ResetControl()
        {
            if (pictureBox1.BackgroundImage == null)
                pictureBox1.BackgroundImage = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Bitmap img = (Bitmap)pictureBox1.BackgroundImage;



            int units = _DatenMuster.Units;
            int length = _DatenMuster.UnitsLength;
            

            Graphics g = Graphics.FromImage(img);
            g.Clear(Color.ForestGreen);
            for (int x = 0; x < units; x++)
                for (int y = 0; y < units; y++)
            if (_DatenMuster.PixelGet(x, y))
                g.FillRectangle(Brushes.Black, new Rectangle(x * length, y * length, length - 1, length - 1));
            else
                g.FillRectangle(Brushes.White, new Rectangle(x * length, y * length, length - 1, length - 1));


            pictureBox1.Invalidate();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (button2.Text != "Stop")
            {
                button2.Text = "Stop";

                richTextBox1.Text = "";
                richTextBox1.Text += "Prozessstart Information aller Daten\r\n";

                for (int i = 0; i < dn.MusterItems.Count; i++)
                {
                    richTextBox1.Text += "Muster "+i+":\r\n" + ((DatenMuster)dn.MusterItems[i]).AS_TEXT + "\r\n";                    
                }
                

                richTextBox1.Text += "-------------------------------------\r\n";
                richTextBox1.Text += "Input" + getArrayText(dn.Input) + "\r\n";
                richTextBox1.Text += "Hidden" + getArrayText(dn.Hidden) + "\r\n";
                richTextBox1.Text += "Output" + getArrayText(dn.Output) + "\r\n";


                _DatenMuster.OutputD = (int)textBox1.Text[0];
                //dnr.Add(_DatenMuster);
                
                dnr.Berechne();

                richTextBox1.Text += "-------------------------------------\r\n";
                richTextBox1.Text += "Input" + getArrayText(dn.Input) + "\r\n";
                richTextBox1.Text += "Hidden" + getArrayText(dn.Hidden) + "\r\n";
                richTextBox1.Text += "Output" + getArrayText(dn.Output) + "\r\n";
                button2.Text = "Lernen";
            }
            else
            {
                dnr.Abort();
                button2.Text = "Lernen";
            }
        }

        void dnr_Step(object sender, EventArgs e)
        {
            DatenNetzBerechnen dnr = (DatenNetzBerechnen)sender;
            //richTextBox1.Text += "QFehler: " + dnr.QFehler + "\r\n";
            label1.Text = "QFehler: " + Math.Round(dnr.QFehler,5) + "\r\n";
        }

        void dnr_Progress(object sender, EventArgs e)
        {
            int p = (int)sender;
            progressBar1.Value = p;
        }


        public string getArrayText(double[] arr)
        {
            string ret = "\r\n";
            for (int i = 0; i < arr.Length; i++)
            {
                ret += arr[i].ToString()+"\r\n";    
            }
            return ret;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            QStyle q = (QStyle)Enum.Parse(typeof(QStyle), comboBox1.Text, true);
            _DatenMuster.ChangeQStyle(q);
            ResetControl();
            
        }

        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void aboutDarkNeuroNetz01ToolStripMenuItem_Click(object sender, EventArgs e)
        {            
            new About().ShowDialog(this);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }



        private void button1_Click_1(object sender, EventArgs e)
        {

        }

        private void pictureBox2_Click_1(object sender, EventArgs e)
        {

        }

        private void splitContainer1_Panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            textBox1.Text = textBox1.Text.ToUpper();
            if(textBox1.Text.Length!=1)
                return;
            char c=textBox1.Text[0];
            int i = (int)c;
            CharInt.Text = "char:" + c + " int:" + i;
            
            
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            //new TMPForm().Show();

        }

        private void pictureBox1_Click_1(object sender, EventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
            new DatenNetzBerechnen(null).TEST();
        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            DatenFile.SaveDlg(dn);
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            DatenNetz tmp=DatenFile.OpenDlgNetz();
            if (tmp != null)
            {
                dn = null;
                dn = tmp;
            }

        }
        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DatenFile.SaveDlg(_DatenMuster);
        }


        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DatenMuster tmp_dm = DatenFile.OpenDlgMuster();
            if (tmp_dm != null)
                _DatenMuster = tmp_dm;
            ResetControl();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            _DatenMuster.OutputDSymbol = textBox1.Text.Substring(0,1);
            dn.MusterItems.Add((DatenMuster)_DatenMuster.Clone());
        }

        private void button5_Click(object sender, EventArgs e)
        {           
            //DatenNetzBerechnen dnr = new DatenNetzBerechnen(dn);
            int z=dnr.Klassifiziere((DatenMuster)_DatenMuster.Clone());
            char c = (char)z;
            string LETTER = new string(new char[] { c });
            MessageBox.Show("Klassifiziert zu: " + LETTER + " " +z);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            dnr.Abort();
        }

        private void propertyGrid1_Click(object sender, EventArgs e)
        {

        }

        private void customizeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dn.ResetBias();
        }

        private void optionsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dn.ResetZwischen();
        }

        private void resetAllesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dn.ResetBias();
            dn.ResetZwischen();
        }
    }
}