using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;
using System.Runtime.Serialization.Formatters.Binary;

namespace Mizel.Neuro
{
    public enum DatenFileType{NETZ,MUSTER};

    public class DatenFile
    {

        internal static void SaveDlg(DatenNetz dn)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.DefaultExt = ".netz";
            sfd.Filter = "Netz (*.netz)|*.netz|All files (*.*)|*.*";
            if (sfd.ShowDialog() == DialogResult.OK)
                Save(sfd.FileName, dn);
        }



        internal static void SaveDlg(DatenMuster dp)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.DefaultExt = ".muster";
            sfd.Filter = "Muster (*.muster)|*.muster|All files (*.*)|*.*";
            if (sfd.ShowDialog() == DialogResult.OK)
                Save(sfd.FileName, dp);
        }

        internal static DatenMuster OpenDlgMuster()
        {
            DatenMuster obj=null;
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.DefaultExt = ".muster";
            ofd.Filter = "Muster (*.muster)|*.muster|All files (*.*)|*.*";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                obj = (DatenMuster)OpenMuster(ofd.FileName);
            }
            return obj;
        }

        internal static DatenNetz OpenDlgNetz()
        {
            DatenNetz obj=null;
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.DefaultExt = ".netz";
            ofd.Filter = "Netz (*.netz)|*.netz|All files (*.*)|*.*";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                obj = (DatenNetz)OpenNetz(ofd.FileName);
            }
            return obj;
        }

        static DatenNetz OpenNetz(string filename)
        {
            return (DatenNetz)Open(filename);
        }
        static DatenMuster OpenMuster(string filename)
        {
            return (DatenMuster)Open(filename);
        }
        

        static void Save(string filename, object tosave)
        {
            FileStream fs = null;
            try
            {
                //BinaryFormatter
                IFormatter AusgabeDatei = new BinaryFormatter();//new SoapFormatter();
                fs = new FileStream(filename, FileMode.OpenOrCreate, FileAccess.ReadWrite);
                AusgabeDatei.Serialize(fs, tosave);
            }

            catch (IOException e)
            { Console.Out.WriteLine("Fehler beim Dateispeichern: " + e); }
            finally
            {
                fs.Close();
            }
        }


        static object Open(string filename)
        {
            object des = null;
            FileStream fs = null;
            try
            {

                IFormatter AusgabeDatei = new BinaryFormatter();//new SoapFormatter();
                fs = new FileStream(filename, FileMode.Open);
                des = AusgabeDatei.Deserialize(fs);
            }
            catch (SerializationException se)
            {
                MessageBox.Show("Datei ist ein Altes Format\r\n" + se.ToString(), "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            /*catch (IOException e)
            { Console.Out.WriteLine("Fehler beim Dateispeichern: " + e); }*/
            catch (Exception e)
            {
                MessageBox.Show("Fehler beim Datei lesen\r\n" + e.ToString(), "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally
            {
                fs.Close();
            }
            return des;
        }





    }
}
