using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Windows.Forms;

namespace Mizel.Neuro
{
    public class DatenNetzBerechnen
    {

        ArrayList _D = new ArrayList();
        ArrayList _Y = new ArrayList();
        DatenNetz _dn = null;
        public event EventHandler Step;
        public event EventHandler Progress;
        double QSUM = 0.0;
        bool IsToAbort;

        public DatenNetzBerechnen(DatenNetz dn)
        {
            this._dn = dn;
        }



        public void Abort()
        {
            IsToAbort = true;
        }



        public void Berechne()
        {
            IsToAbort = false;
            for (int z = 0; z < 1000; z++)
            {
                QSUM = 0.0;
                for (int m = 0; m < _dn.MusterItems.Count; m++)
                {
                    Application.DoEvents();
                    DatenMuster dp = (DatenMuster)_dn.MusterItems[m];
                    Rechne_Forward(dp);
                    Application.DoEvents();
                    Backprop(dp);
                    Application.DoEvents();
                    QSUM += QFeheler(IntToDoubleArr(dp.OutputD), _dn.Output);                                        
                }
                OnStep();
                OnProgress((double)z/1000);

                if (QSUM < 0.04 || IsToAbort)
                    break;
             

                    Round();
            }


            //int SummeFq = 0;
            //for (int i = 0; i < _D.Count; i++)
            //{
            //    double[] d = (double[])_Ausgabe[i];
            //    _Y[i]=DoubleArrToInt(d);
            //    int Fq = (int)_D[i] - (int)_Y[i];                
            //    SummeFq += Fq * Fq;
            //}
            


           
        }

        private void Round()
        {
            int rounddecimals=3;
            for (int h = 0; h < _dn.HiddenSize; h++)
                for (int i = 0; i < _dn.InputSize; i++)
                    _dn.Gewichte1_2[i, h] =Math.Round(_dn.Gewichte1_2[i, h],rounddecimals);

            for (int o = 0; o < _dn.OutputSize; o++)
                for (int h = 0; h < _dn.HiddenSize; h++)
                    _dn.Gewichte2_3[h, o]=Math.Round(_dn.Gewichte2_3[h, o],rounddecimals);

        }

        private void OnProgress(double p)
        {
            if (Progress != null)
                Progress((int)(p*100), EventArgs.Empty);

        }

        public double NET(double toEXP)
        {
            return 1/(1 + Math.Exp(-toEXP));
        }

        void Rechne_Forward(DatenMuster dm)
        {
            
            for (int h = 0; h < _dn.HiddenSize; h++)
            {
                for (int i = 0; i < _dn.InputSize; i++)
                {
                    _dn.Hidden[h] += _dn.Gewichte1_2[i, h] * dm[i + h] + _dn.BIAS_H[h];
                }
                //transferfunktion
                //      1
                //  1+exp(-NET)
                _dn.Hidden[h] = NET(_dn.Hidden[h]);
            }

            for (int o = 0; o < _dn.OutputSize; o++)
            {
                for (int h = 0; h < _dn.HiddenSize; h++)
                {
                    _dn.Output[o] += _dn.Gewichte2_3[h, o] * _dn.Hidden[h] + _dn.BIAS_O[o];
                }
                _dn.Output[o] = NET(_dn.Output[o]);
            }
        }

        void Backprop(DatenMuster dm)
        {
            double[] D = IntToDoubleArr(dm.OutputD);
            double[] Fk = new double[_dn.OutputSize];
            double[] Fkv = new double[_dn.HiddenSize];

            //Fk fr Hidden->Output  Berechnen
            for (int o = 0; o < _dn.OutputSize; o++)
                Fk[o] = (D[o] - _dn.Output[o]) * _dn.Output[o] * (1 - _dn.Output[o]);    

            //OutputLayer
            for (int o = 0; o < _dn.OutputSize; o++)
            {                
                for (int h = 0; h < _dn.HiddenSize; h++)
                {
                    _dn.Gewichte2_3[h, o]=_dn.Gewichte2_3[h, o] + (_dn.Output[o]*Fk[o]);
                }
                _dn.BIAS_O[o] = _dn.BIAS_O[o] + (Fk[o] * _dn.BIAS_O[o]);
            }

            //Fkv fr Input->Hidden Berechnen            
            for (int h = 0; h < _dn.HiddenSize; h++)
            {
                double Fsum = 0.0;
                for (int fi = 0; fi < Fk.Length; fi++)
                    Fsum += Fk[fi] * _dn.Gewichte2_3[h,fi];
                Fkv[h] = Fsum * _dn.Hidden[h] * (1 - _dn.Hidden[h]);
            }
            
            //Hiddenlayer
            for (int h = 0; h < _dn.HiddenSize; h++)
            {
                for (int i = 0; i < _dn.InputSize; i++)
                {
                    _dn.Gewichte1_2[i, h] = _dn.Gewichte1_2[i, h] + (Fkv[h] * _dn.Input[i]);
                }
                _dn.BIAS_H[h] = _dn.BIAS_H[h] + (Fkv[h] * _dn.BIAS_H[h]);
            }
        }

        int DoubleArrToInt(double[] arg)
        {
            int tmp = 0;
            int fill = 0;
            for (int i = arg.Length-1; i>=0; i--)
            {
                double var = arg[i];
                tmp = 0;
                if (var > 0.8)
                    tmp = 1;
                else
                    tmp = 0;
                fill = fill | tmp;
                fill = fill << 1;
            }
            fill = fill >> 1;
            return fill;
        }

        double[] IntToDoubleArr(int arg)
        {
            double[] ret = new double[8];
            for (int i = 0; i < 8; i++)
                ret[i] = (double)((arg & 0x01<<i)>>i);
            return ret;
        }

        public void TEST()
        {
            int i = 123;
            double[] tmp = IntToDoubleArr(i);
            int ret = DoubleArrToInt(tmp);
            if (ret == i)
                i++;

            double[] d = IntToDoubleArr(255);
            double[] y = IntToDoubleArr(0);
            double q=QFeheler(d, y);
            q += 0.1;

        }


        double QFeheler(double[] d, double[] y)
        {
            double sum=0.0;
            for (int i = 0; i < d.Length; i++)
                sum += Math.Pow(d[i] - y[i],2.0);
            return sum;
        }

        private void OnStep()
        {
            if(Step!=null)
                Step(this,EventArgs.Empty);
        }
        

        public double QFehler
        {
            get { return QSUM; }
        }


        internal int Klassifiziere(DatenMuster dm)
        {
           
            for (int h = 0; h < _dn.HiddenSize; h++)
            {
                for (int i = 0; i < _dn.InputSize; i++)
                {
                    _dn.Hidden[h] += _dn.Gewichte1_2[i, h] * dm[i + h] + _dn.BIAS_H[h];
                }
                //transferfunktion
                //      1
                //  1+exp(-NET)
                _dn.Hidden[h] = NET(_dn.Hidden[h]);
            }

            for (int o = 0; o < _dn.OutputSize; o++)
            {
                for (int h = 0; h < _dn.HiddenSize; h++)
                {
                    _dn.Output[o] += _dn.Gewichte2_3[h, o] * _dn.Hidden[h]+_dn.BIAS_O[o];
                }
                _dn.Output[o] = NET(_dn.Output[o]);
            }

            return DoubleArrToInt(_dn.Output);
        }
    }
}
