using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

using Mizel.Neuro;

namespace WindowsApplication1
{
    [DesignerAttribute(typeof(NeuroViewDesigner))]
    public partial class NeuroViewer : System.Windows.Forms.PictureBox
    {


        public NeuroViewer()
        {
            InitializeComponent();
            Init();
        }

        public NeuroViewer(IContainer container)
        {
            container.Add(this);
            InitializeComponent();
            Init();
        }

        void Init()
        { 
            //Methoden
            this.MouseClick+= new System.Windows.Forms.MouseEventHandler(_MouseMove);
            this.BackgroundImage = null;
            this.BackgroundImage = new Bitmap(300, 300);
            ResetControl();
        }

        void _MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            //if (this.BackgroundImage == null)
              //  this.BackgroundImage = new Bitmap(this.Width, this.Height);
            Bitmap img = (Bitmap)this.BackgroundImage;


            int posx = (e.X) / unitslength;
            int posy = (e.Y) / unitslength;

            this.DatenMuster.PixelChange(posx, posy);
            ResetControl();
        }

        private void ResetControl()
        {
            //if (this.BackgroundImage == null)
              //  this.BackgroundImage = new Bitmap(this.Width, this.Height);
            Bitmap img = (Bitmap)this.BackgroundImage;



            Graphics g = Graphics.FromImage(img);
            g.Clear(Color.ForestGreen);
            for (int x = 0; x < units; x++)
                for (int y = 0; y < units; y++)
                    if (this.DatenMuster.PixelGet(x, y))
                        g.FillRectangle(Brushes.Black, new Rectangle(x * unitslength, y * unitslength, unitslength - 1, unitslength - 1));
                    else
                        g.FillRectangle(Brushes.White, new Rectangle(x * unitslength, y * unitslength, unitslength - 1, unitslength - 1));

            this.Invalidate();
        }



        private DatenMuster _datenmuster=new DatenMuster(16,new Size(300,300));
        public DatenMuster DatenMuster
        {
            get { return _datenmuster; }
            set { _datenmuster = value; }
        }

        

        public int units
        {
            get { return this.DatenMuster.Units; }            
        }

        public int unitslength
        {
            get { return this.DatenMuster.UnitsLength;
            }
        }
	


        




    }






    
    public class NeuroViewDesigner : System.Windows.Forms.Design.ControlDesigner
    {
        protected override void PreFilterProperties(System.Collections.IDictionary properties)
        {
            base.PreFilterProperties(properties);
            foreach (string prop in unneededProperties)
            {
                System.Diagnostics.Debug.WriteLine("Hidding Property {0}", prop);
                properties.Remove(prop);
            }
        }

        #region Control tidy-up logic
        private static readonly string[] unneededProperties = 
        {
            "CausesValidation",
            "ImeMode",
            "AccessibleDescription",
            "AccessibleName",
            "AccessibleRole",
            "AllowDrop",
            "Locked",
            "AutoScroll",
            "AutoScrollMargin",
            "AutoScrollMinSize",
            "BorderStyle",
            "DockPadding",
            "ContextMenu",
            "Padding",            
            "RightToLeft",            
            "Tag"
        };
        #endregion
    }
}
